package be.tarsos.dsp.android;

import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;

/**
 * Created by joren on 12/10/14.
 */
public class AudioPlayer {

    final AudioTrack track;
    final byte[] byteBuffer;

    public AudioPlayer(){
        int sampleRate =  AudioTrack.getNativeOutputSampleRate(AudioTrack.MODE_STATIC);
        int length = sampleRate /4;
        byteBuffer = new byte[length*2];
        for (int i = 0; i < length; i++) {
           int x = 32768 - ((i % 600) * 660);
           byteBuffer[2*i] = (byte) x;
           byteBuffer[2*i+1] = (byte) (x >>> 8);
        }

        track = new AudioTrack(AudioManager.STREAM_NOTIFICATION,sampleRate, AudioFormat.CHANNEL_OUT_MONO,AudioFormat.ENCODING_PCM_16BIT,byteBuffer.length,AudioTrack.MODE_STATIC);

        track.write(byteBuffer,0,byteBuffer.length);
    }

    public void play(){

        switch (track.getPlayState()) {
            case AudioTrack.PLAYSTATE_PAUSED:
                track.stop();
                track.reloadStaticData();
                track.play();
                break;
            case AudioTrack.PLAYSTATE_PLAYING:
                track.stop();
                track.reloadStaticData();
                track.play();
                break;
            case AudioTrack.PLAYSTATE_STOPPED:
                track.reloadStaticData();
                track.play();
                break;
        }
    }
}
